/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.datastructure
 * File:    DataContainer.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.datastructure;

import de.fhhannover.inform.ifmap.event.IdentifierChangedReceiver;

public class DataContainer
implements IdentifierChangedReceiver{
	
	private IdentifierContainer identifier = new IdentifierContainer();
	
	public DataContainer(){}
	
	public DataContainer(IdentifierContainer conti){
		identifier = conti;
	}
	
	public void addIdentifier(Identifier ident){
		if(!identifier.contains(ident)){
			identifier.add(ident);
		}
	}
	
	public void addIdentifier(IdentifierContainer conti){
		// we step through all identifier
		for(Identifier ident : conti){
			// do we have already this identifier?
			if(!exists(ident)){
				this.identifier.add(ident);
			}
			else{
				
			}
		}
	}
	
	private boolean exists(Identifier ident){
		for(Identifier i : identifier){
			if(ident.getUniqueIdentifierName().equals(i.getUniqueIdentifierName())){
				return true;
			}
		}
		return false;
	}
	
	public void removeIdentifier(Identifier ident){
		if(identifier.contains(ident)){
			identifier.remove(ident);
		}
	}
	
	public IdentifierContainer getAllIdentifier(){
		return identifier;
	}

	@Override
	public void processDelete(IdentifierContainer conti) {
	 for(Identifier ident : conti){
		for(Identifier i : identifier){
			if(i.getUniqueIdentifierName().equals(ident.getUniqueIdentifierName())){
				this.identifier.remove(i);
			}
		}
	 }
	}

	@Override
	public void processNew(IdentifierContainer conti) {
		for(Identifier ident : conti){
			this.identifier.add(ident);
		}		
	}

	@Override
	public void processUpdate(IdentifierContainer conti) {
		for(Identifier ident : conti){
			for(Identifier i : identifier){
				if(i.getUniqueIdentifierName().equals(ident.getUniqueIdentifierName())){
					for(LinkContainer l : ident.getLinks()){
						for(LinkContainer l2 : i.getLinks()){
							if(l.getUniqueLinkName().equals(l2.getUniqueLinkName())){
								for(Link link : l.getLinks()){
									l.addLink(link);
								}
							}
						}
					}
				}
		}
	}
  }
}