/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.util
 * File:    AppLauncher.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.util;

import java.io.IOException;
import java.net.URISyntaxException;

public class AppLauncher {
	public static boolean openWebpageInBrowser(String url){
		if(java.awt.Desktop.isDesktopSupported()) {
			java.awt.Desktop desktop = java.awt.Desktop.getDesktop();
			if(desktop.isSupported(java.awt.Desktop.Action.BROWSE)) {
				java.net.URI uri;
				try {
					uri = new java.net.URI(url);				
					desktop.browse(uri);
					return true;
				} catch (IOException e) {
					e.printStackTrace();
					return false;					
				} catch (URISyntaxException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
			}
			
		}
	}
	return false;
 }
}
